#
# Ronin Exploits - A Ruby library for Ronin that provides exploitation and
# payload crafting functionality.
#
# Copyright (c) 2007-2009 Hal Brodigan (postmodern.mod3 at gmail.com)
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#

require 'ronin/controls/exceptions/not_implemented'
require 'ronin/controls/file_system'

module Ronin
  module Controls
    module Helpers
      module FileWrite
        include FileSystem

        #
        # Writes the specified _contents_ to the file at the specified
        # _path_.
        #
        # @since 0.3.0
        #
        def write_file(path,contents)
          raise(NotImplemented,"the write_file method has not been implemented",caller)
        end

        #
        # Appends the specified _contents_ to the file at the specified
        # _path_.
        #
        # @since 0.3.0
        #
        def append_file(path,contents)
          raise(NotImplemented,"the append_file method has not been implemented",caller)
        end

        #
        # Touches the file at the specified _path_.
        #
        # @since 0.3.0
        #
        def touch(path)
          write_file(path,'')
        end
      end
    end
  end
end
