#
# Ronin Exploits - A Ruby library for Ronin that provides exploitation and
# payload crafting functionality.
#
# Copyright (c) 2007-2009 Hal Brodigan (postmodern.mod3 at gmail.com)
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#

require 'ronin/exploits/remote_tcp'
require 'ronin/network/helpers/http'

module Ronin
  module Exploits
    class HTTP < RemoteTCP

      # Default port to connect to
      DEFAULT_PORT = 80

      include Network::Helpers::HTTP

      #
      # Creates a new Ronin::Exploits::HTTP object using the given _block_.
      #
      #   ronin_http_exploit do
      #     ...
      #   end
      #
      contextify :ronin_http_exploit

      # The optional URL path prefix
      parameter :url_prefix,
                :description => 'Optional URL path prefix'

    end
  end
end
