#
# Ronin Exploits - A Ruby library for Ronin that provides exploitation and
# payload crafting functionality.
#
# Copyright (c) 2007-2009 Hal Brodigan (postmodern.mod3 at gmail.com)
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#

require 'dm-core'

module Ronin
  module Model
    module HasDefaultPort
      def self.included(base)
        base.module_eval do
          # Default port to use
          property :default_port, Integer

          validates_present :default_port
        end
      end

      #
      # Creates a new Model.
      #
      # @param [Hash] attributes
      #   Additional attributes to initialize the model with.
      #
      # @option attributes [Integer] :default_port (DEFAULT_PORT)
      #   The default port to connect to.
      #
      def initialize(attributes={},&block)
        if self.class.const_defined?('DEFAULT_PORT')
          attributes = {:default_port => self.class.const_get('DEFAULT_PORT')}.merge(attributes)
        end

        super(attributes,&block)
      end
    end
  end
end
