require 'ronin/exploits/remote_udp'

require 'spec_helper'

describe Exploits::RemoteUDP do
  before(:all) do
    @exploit = Exploits::RemoteUDP.new(
      :default_port => 22,
      :host => '127.0.0.1'
    )
  end

  it "should include the UDP Session module" do
    Exploits::RemoteUDP.include?(Network::Helpers::UDP).should == true
  end

  it "should initialize all parameters by default" do
    @exploit.params.should_not be_empty
  end

  it "should default the port to the default_port before deploying" do
    @exploit.build!

    @exploit.deploy! do |exp|
      exp.port.should == 22
    end
  end
end
