require 'ronin/exploits/web'

require 'spec_helper'

describe Exploits::Web do
  describe "targeted_url" do
    it "should initialize all parameters by default" do
      exploit = Exploits::Web.new
      
      exploit.params.should_not be_empty
    end

    it "should create a targeted URL using the host param" do
      host = 'www.example.com'
      exploit = Exploits::Web.new(:host => host)

      exploit.targeted_url.host.should == host
    end

    it "should create a targeted URL using the host param and the url_path property" do
      host = 'www.example.com'
      path = '/'
      exploit = Exploits::Web.new(:host => host, :url_path => path)

      exploit.targeted_url.host.should == host
      exploit.targeted_url.path.should == path
    end

    it "should raise a MissingParam exception if host params is missing" do
      exploit = Exploits::Web.new(:url_path => '/')

      lambda { exploit.targeted_url }.should raise_error(Parameters::MissingParam)
    end
  end
end
